#ifndef GLOBPREP_H
#define GLOBPREP_H

#include "siftop.h"
#include "aliast.h"
#include "globalt.h"

#include "dbcrs.h"
#include "dbmat.h"
#include "bocon.h"
#include "edgeload.h"
#include "sourceload.h"
#include "inicon.h"
#include "bocone.h"
#include "surfboc.h"

extern siftop  *Top;    ///< Sifel topology
extern long     Npropn; ///< number of entries with nodal property
extern long     Nprope; ///< number of entries with element property

// Folowing arrays have size equal to number of lines with property description
//  of nodes(elements).
// This numbers are specified in the input file on the first line before section
//  described nodals or elements property
extern bocon    **Boc;    ///< array of pointers to the nodal boundary conditions structures
extern long     **Boccn;  /**< array with bocon squence number (0 : if Boc[i] == NULL)
                             (positive number : if Boc[i] != NULL)*/
extern long        *Nnp;    ///< property numbers for nodes
extern long        *Nep;    ///< property numbers for elements
extern elemtypet   *Tel;    ///< array of element types
extern long        *Sel;    ///< array with element shape number
extern long        *Nmel;   ///< number of materials on the element
extern mattypet   **Mel;    ///< array of material types
extern long       **Melid;  ///< array of material indeces
extern crsectypet  *Ncs;    ///< array of cross-section types in the nodes
extern long        *Ncsi;   ///< array of cross-section indeces in the nodes
extern crsectypet  *Ecs;    ///< array of cross-section types in the elements
extern long        *Ecsi;   ///< array of cross-section indeces in the elements
extern dbmat       *Dbmat;  ///< database of materials and their parameters
extern dbcrs       *Dbcrs;  ///< database of cross-sections and their parameters
extern elemtypet   *Tet;    ///< array of element type for each element
extern long        *Nmu;    ///< array with indicators of used material types from material database
extern long        *Ncu;    ///< array with indicators of used cross-section types from cross-section database
extern long         Nlc;    ///< number of loading cases
extern long         Ndofn;  ///< number of dof for nodes
extern long         Nspv;   ///< number of prescribed values
extern long         Csrin;  ///< number of renumbered index in function wr_nodes
extern long       **Nccn;   ///< array of pointers to common code numbers in the nodes
extern inicon     **Inic;   ///< array of pointers to the nodal initial conditions structures
extern edgeload   **Edgl;   ///< array of pointers to the edge load structures
extern sourceload **Sl;     ///< array of pointers to the edge load structures
extern bocone     **Boce;   ///< array of pointers to boundary conditions on elements
extern surfboc    **Surfbc; ///< array of pointers to boundary conditions on surfaces
extern gfunct      *Tf;     ///< array of time functions used in time dependent mechanical problems for each load case
#endif
