#include "crsection1d.h"
#include "globalt.h"
#include "stochdrivert.h"

crsection1d::crsection1d (void)
{
  a=0.0;  rho=0.0;
}
crsection1d::~crsection1d (void)
{
  
}

void crsection1d::read (XFILE *in)
{
  switch (Tp->tprob){
  case stationary_problem:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case nonlinear_stationary_problem:{
    xfscanf (in,"%lf",&a);
    break;
  }
  case nonstationary_problem:{
    xfscanf (in,"%lf %lf",&rho,&a);
    break;
  }
  case nonlinear_nonstationary_problem:{
    xfscanf (in,"%lf %lf",&rho,&a);
    break;
  }
  case discont_nonstat_problem:{
    xfscanf (in,"%lf %lf",&rho,&a);
    break;
  }
  case discont_nonlin_nonstat_problem:{
    xfscanf (in,"%lf %lf",&rho,&a);
    break;
  }
  case growing_np_problem:{
    xfscanf (in,"%lf %lf",&rho,&a);
    break;
  }
  case growing_np_problem_nonlin:{
    xfscanf (in,"%lf %lf",&rho,&a);
    break;
  }
  default:{
    fprintf (stderr,"\n\n unknown problem type is required in function crsection1d::read (file %s, line %d).\n",__FILE__,__LINE__);
  }
  }
}

void crsection1d::print (FILE *out)
{
  switch (Tp->tprob){
  case stationary_problem:{
    fprintf (out," %lf\n",a);
    break;
  }
  case nonstationary_problem:{
    fprintf (out," %lf %lf\n",rho,a);
    break;
  }
  case nonlinear_nonstationary_problem:
  case discont_nonlin_nonstat_problem:
  case growing_np_problem:
  case growing_np_problem_nonlin:{
    fprintf (out," %lf %lf",rho,a);
    break;
  }
  default:{
    fprintf (stderr,"\n\n unknown problem type is required in function crsection1d::read (file %s, line %d).\n",__FILE__,__LINE__);
  }
  }
}

void crsection1d::changeparam (atsel &atcs,vector &val)
{
  long i;
  
  for (i=0;i<atcs.num;i++){
    switch (atcs.atrib[i]){
    case 0:{
      a=val[0];
      break;
    }
    case 1:{
      rho=val[1];
      break;
    }
    default:{
      fprintf (stderr,"\n\n wrong number of atribute in function changeparam (file %s, line %d).\n",__FILE__,__LINE__);
    }
    }
  }
}
