#ifndef INTPOINTST_H
#define INTPOINTST_H

#include <stdio.h>
#include "aliast.h"
#include "genfile.h"

/**
   class intpoints
*/
class intpointst
{
 public:
  intpointst (void);
  ~intpointst (void);
  void read (FILE *in);
  void alloc (long ipp);
  void clean ();
  void save_data (FILE *aux);
  void restore_data (FILE *aux);
  void actual_previous_change ();

  ///  material type
  mattypet tm;
  ///  material id
  long idm;

  ///  number of component of flux/grad array
  long ncompgrad;
  ///  number of component of other array
  long ncompother;
  ///  number of component of eqother array
  long ncompeqother;

  ///  array of actual values
  double *av;
  ///  array of previous values
  double *pv;
  ///  array of gradients
  double **grad;
  ///  array of fluxes
  double **fluxes;
  ///  other components
  double *other;
  ///  eqother components
  double *eqother;
};

#endif
