#include "solvert.h"
#include "spsolvert.h"
#include "nspsolvert.h"
#include "npsolvert.h"
#include "nnpsolvert.h"
#include "cpnpsolvert.h"
#include "cpnnpsolvert.h"
#include "dnpsolvert.h"
#include "dnnpsolvert.h"
#include "globalt.h"

void solve_trfel_problem (stochdrivert *stochd)
{
  if (Tp->stochasticcalc==0){
    solve_trfel_deterministic_problem ();
  }
  if (Tp->stochasticcalc==1){
    solve_trfel_stochastic_problem (stochd);
  }
}

void solve_trfel_deterministic_problem ()
{
  switch (Tp->tprob){
  case stationary_problem:{
    solve_stationary_problem ();
    break;
  }
  case nonlinear_stationary_problem:{
    solve_nonlinear_stationary_problem ();
    break;
  }
  case nonstationary_problem:{
    solve_nonstationary_problem ();
    break;
  }
  case nonlinear_nonstationary_problem:{
    solve_nonlinear_nonstationary_problem ();
    break;
  }
  case growing_np_problem:{
    //solve_nonstationary_growing_problem ();
    solve_nonstationary_growing_vform ();
    break;
  }
  case growing_np_problem_nonlin:{
    solve_nonstationary_growing_problem_nonlin ();
    break;
  }
  case discont_nonstat_problem:{
    solve_discont_nonstationary_problem ();
    break;
  }
  case discont_nonlin_nonstat_problem:{
    solve_discont_nonlin_nonstationary_problem ();
    break;
  }
  default:{
    print_err("unknown problem type is required",__FILE__,__LINE__,__func__);
  }
  }
}

void solve_trfel_stochastic_problem (stochdrivert *stochd)
{
  print_err("stochastic transport problems are not implemented at this time",__FILE__,__LINE__,__func__);
}
