#include "spsolvert.h"
#include "globalt.h"
#include "globmatt.h"
#include "transprint.h"
#include <string.h>
#include "npsolvert.h"

/**
   function solves linear stationary transport problem

   JK, 20.12.2002
*/
void solve_stationary_problem ()
{
  long i;
  double *rhs;
  
  //  conductivity matrix assembling
  conductivity_matrix (0);
  
  rhs=Lsrst->give_rhs (0);
  
  //  right hand side of the system
  for (i=0;i<Lsrst->nlc;i++){
    trfel_right_hand_side (i,rhs,Ndoft);
  }
  
  /*
  long j;
  FILE *p;
  p = fopen ("matice.txt","w");
  fprintf (p,"%ld %ld\n",Ndoft,Kmat->cr->negm);
  for (i=0;i<Ndoft;i++){
    for (j=Kmat->cr->adr[i];j<Kmat->cr->adr[i+1];j++){
      fprintf (p,"%ld %ld  %20.15le\n",i,Kmat->cr->ci[j],Kmat->cr->a[j]);
    }
  }
  fclose (p);
  p = fopen ("vektor.txt","w");
  fprintf (p,"%ld\n",Ndoft);
  for (i=0;i<Ndoft;i++){
    fprintf (p,"%20.15le\n",rhs[i]);
  }
  fclose (p);
  
  abort ();
  */


  //  solution of equation system
  for (i=0;i<Lsrst->nlc;i++){
    //Kmat->solve_system (Gtt,Lsrst->give_lhs(i),Lsrst->give_rhs(i));
    Tp->ssle->solve_system (Gtt,Kmat,Lsrst->give_lhs(i),Lsrst->give_rhs(i),Outt);

  }
  
  print_initt(-1, "wt");    
  for (i=0;i<Lsrst->nlc;i++){
    //  computes and prints required quantities
    print_stept(i, 0, 0.0, NULL);    
  }
  print_closet();
}
